# coding: utf-8

"""
    Gate API v4

    Welcome to Gate API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.   # noqa: E501

    Contact: support@mail.gate.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class AccountsResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'currency': 'str',
        'available': 'str',
        'locked': 'str',
        'token_address': 'str',
        'chain': 'str'
    }

    attribute_map = {
        'currency': 'currency',
        'available': 'available',
        'locked': 'locked',
        'token_address': 'token_address',
        'chain': 'chain'
    }

    def __init__(self, currency=None, available=None, locked=None, token_address=None, chain=None, local_vars_configuration=None):  # noqa: E501
        # type: (str, str, str, str, str, Configuration) -> None
        """AccountsResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._currency = None
        self._available = None
        self._locked = None
        self._token_address = None
        self._chain = None
        self.discriminator = None

        if currency is not None:
            self.currency = currency
        if available is not None:
            self.available = available
        if locked is not None:
            self.locked = locked
        if token_address is not None:
            self.token_address = token_address
        if chain is not None:
            self.chain = chain

    @property
    def currency(self):
        """Gets the currency of this AccountsResponse.  # noqa: E501

        Currency name  # noqa: E501

        :return: The currency of this AccountsResponse.  # noqa: E501
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this AccountsResponse.

        Currency name  # noqa: E501

        :param currency: The currency of this AccountsResponse.  # noqa: E501
        :type: str
        """

        self._currency = currency

    @property
    def available(self):
        """Gets the available of this AccountsResponse.  # noqa: E501

        Available Balance  # noqa: E501

        :return: The available of this AccountsResponse.  # noqa: E501
        :rtype: str
        """
        return self._available

    @available.setter
    def available(self, available):
        """Sets the available of this AccountsResponse.

        Available Balance  # noqa: E501

        :param available: The available of this AccountsResponse.  # noqa: E501
        :type: str
        """

        self._available = available

    @property
    def locked(self):
        """Gets the locked of this AccountsResponse.  # noqa: E501

        锁定余额  # noqa: E501

        :return: The locked of this AccountsResponse.  # noqa: E501
        :rtype: str
        """
        return self._locked

    @locked.setter
    def locked(self, locked):
        """Sets the locked of this AccountsResponse.

        锁定余额  # noqa: E501

        :param locked: The locked of this AccountsResponse.  # noqa: E501
        :type: str
        """

        self._locked = locked

    @property
    def token_address(self):
        """Gets the token_address of this AccountsResponse.  # noqa: E501

        token 地址  # noqa: E501

        :return: The token_address of this AccountsResponse.  # noqa: E501
        :rtype: str
        """
        return self._token_address

    @token_address.setter
    def token_address(self, token_address):
        """Sets the token_address of this AccountsResponse.

        token 地址  # noqa: E501

        :param token_address: The token_address of this AccountsResponse.  # noqa: E501
        :type: str
        """

        self._token_address = token_address

    @property
    def chain(self):
        """Gets the chain of this AccountsResponse.  # noqa: E501

        区块链名称  # noqa: E501

        :return: The chain of this AccountsResponse.  # noqa: E501
        :rtype: str
        """
        return self._chain

    @chain.setter
    def chain(self, chain):
        """Sets the chain of this AccountsResponse.

        区块链名称  # noqa: E501

        :param chain: The chain of this AccountsResponse.  # noqa: E501
        :type: str
        """

        self._chain = chain

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccountsResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AccountsResponse):
            return True

        return self.to_dict() != other.to_dict()
